open ExtString;; 
open Commons;;

let decode_value str =
	let ishex = function '0'..'9' | 'A'..'F' -> true | _ -> false in
	let hex c = match c with
		| '0'..'9' -> int_of_char c - 48
		| 'A'..'F' -> int_of_char c - 55
		| _ -> 0  in
	let rec conv = function
		| '%' :: a :: b :: tl when ishex a && ishex b -> (char_of_int ((hex a)*16 + hex b)) :: conv tl
		| a :: tl -> a :: conv tl
		| [] -> []  in
	str |> String.replace_chars (function '+'->" "|c->Std.string_of_char c) |> String.explode |> conv |> String.implode;;   

module M = Map.Make(String);;

let do_cgi () =
	let input = Std.input_all stdin in
	try
		let req = String.nsplit input "&" |> List.map (fun pair-> 
			match String.nsplit pair "=" with
			| name :: value :: [] -> name, decode_value value
			| _ -> raise Not_found)
		|> List.fold_left (fun m (name, value) -> M.add name value m) M.empty		in 
		print_string "Content-type: text/html\n\n";
		let resolve_color name = try M.find name req with Not_found -> "" in
		let code =
			let src = M.find "source" req in
			if M.mem "Normal" req then Ocolor.process_custom resolve_color src else Ocolor.process src in
		Printf.printf "<html><body>HTML code:<br><form><textarea rows=10 cols=120>%s</textarea></form>\n" code;
		Printf.printf "<p>Sample:<hr>\n%s\n<hr>" code 
	with Not_found ->
		Printf.printf "Content-type: text/plain\n\nError! Input:\n%s" input;;
		

if Array.length Sys.argv > 1 then
	Std.input_all stdin |> Ocolor.process |> print_string
else do_cgi ();; 